package etm;
import robocode.Robot;
import robocode.ScannedRobotEvent;

/**
 * Creates a robot that continually rotates the gun
 * finds a single target and shoots only at that one target.
 * If the target dies, just spins forever
 * @author Edward Meyer
 */
public class Firing02 extends Robot {
	String trackName; //Used to hold the name of current target

	public void run() {
		//Forever rotate gun 24 degrees every turn
		while (true) {turnGunRight(24);}
	}

	public void onScannedRobot(ScannedRobotEvent e) {
		//If robot currently does not have a target, it does now
		if (trackName == null) {
			trackName = e.getName();
			fire(1);
		}//else, check is scanned robot is target, if so, fire 
		else if (trackName.equals(e.getName())) {
			fire(1);
		}
	}
}
