package etm;
import robocode.Robot;
import robocode.ScannedRobotEvent;

/**
 * Creates a robot that fires at any scanned robot, but uses
 * power proportional to the distance of the scanned robot
 * Will use more power on closer robots, and less on farther
 * @author Edward Meyer
 *
 */
public class Firing03 extends Robot {
	public void run() {
		//Continually rotate gun every turn
		while (true) {turnGunRight(24);}
	}
	
	public void onScannedRobot(ScannedRobotEvent e) {
		/* Fire at any scanned robot, proportional to distance
		   Fire formula was found by classmate Kendyll Doi
		   At max distance, lower fire is .1, and at closest distance
		   fire power is capped at 3 */
		fire(3.1 - e.getDistance()/1200 * 3);
	}
}
