package etm;
import static robocode.util.Utils.normalRelativeAngleDegrees;
import robocode.Robot;

/**
 * Creates a robot that moves to opposite corners
 * starting with the upper left corner
 * @author Edward Meyer
 *
 */

public class Movement05 extends Robot {
	
	public void run() {
		
		double currentY = getY(); //Get current X and Y of robot
		double currentX = getX();
		double maxSizeX = getBattleFieldWidth(); //Get the battlefields dimensions
		double maxSizeY = getBattleFieldHeight();
		
		//Go to upper left using Manhattan Distance, traversing up then to the left
		//Sometimes angle is too steep to use trig and will hit a wall if trying to compute angle to turn
		turnRight(normalRelativeAngleDegrees(360 - getHeading()));
		ahead(maxSizeY - currentY);
		turnLeft(90);
		ahead(currentX);
				
		//Moving to lower right
		/* Need to set adjacent side to negative in arctan because the
		   robot is in the second quadrant taking lower right as origin */
		turnRight(normalRelativeAngleDegrees(Math.atan(maxSizeX/(0 - maxSizeY))*(180/Math.PI)-getHeading() - 180) );
		//Use Pythagorean Theorem to calculate distance to travers
		ahead(Math.sqrt(Math.pow(maxSizeX, 2) + Math.pow(maxSizeY, 2)));
		
		/* Moving to upper right, since moving directly up, just need to
		   turn facing 360 degrees and travel the height of the battlefield */
		turnRight(360 - getHeading());
		ahead(maxSizeY);
		
		//Moving to lower left
		/* Calculates the angle to turn using arctan, and Pythagorean Theorem 
		   to calculate distance to travel */
		turnRight(normalRelativeAngleDegrees(Math.atan((maxSizeX)/(maxSizeY))*(180/Math.PI)-getHeading()) - 180);
		ahead(Math.sqrt(Math.pow(maxSizeX, 2) + Math.pow(maxSizeY, 2)) - 18);
		
		
	}
}
