package etm;
import static robocode.util.Utils.normalRelativeAngleDegrees;
import robocode.Robot;
import robocode.ScannedRobotEvent;

/**
 * Creates a robot that finds the nearest robot and moves
 * in the opposite direction by 100 pixels
 * @author Edward Meyer
 */
public class Tracking03 extends Robot {
	double gunTurnAmt; // How much to turn our gun when searching
	
	public void run() {
		setAdjustGunForRobotTurn(true);
		/* turnGunRight 24 degrees at each turn to find target,
		   using 24 because that is the maximum degree 
		   the gun can move in 1 turn */
		while (true) {turnGunRight(24);}
	}
	
	public void onScannedRobot(ScannedRobotEvent e) {
		//Calculate how much to turn gun to point towards target and point
		gunTurnAmt = normalRelativeAngleDegrees(e.getBearing() + (getHeading() - getRadarHeading()));
		turnGunRight(gunTurnAmt);
		
		//reposition robot to be facing target and move back 100 pixels
		turnRight(e.getBearing());
		back(100);
	}
		
}
